module ani_image
!
! Imaging Condition -- crosscorrelation
!

use ani_type
use ani_parms

implicit none

contains
!=====================================================================================
subroutine aniimage(adj,iw,ws,wr,image,ssou)
logical					:: adj
logical, optional                                 :: ssou
integer					:: isecdim, ihso, ith, ixw,iw,sign
complex					:: wr(:),ws(:)
real					:: image(:,:),hto

   if (adj) then
      do ixw=1,kxm%n
         do isecdim=1,nsecdim
            ihso=nint(((isecdim-1)*dsecdim+osecdim)/dx)
            if (ixw-ihso >= 1 .and. ixw-ihso <= kxm%n .and. ixw+ihso >= 1 .and. ixw+ihso <= kxm%n) then
               if (ssou) then
                  ws(ixw-ihso)=ws(ixw-ihso)+wr(ixw+ihso)*image(ixw,isecdim)
               else
                  wr(ixw+ihso)=wr(ixw+ihso)+ws(ixw-ihso)*image(ixw,isecdim)
               end if
            end if
         end do
      end do
   else
      do ixw=1,kxm%n
         do isecdim=1,nsecdim
            ihso=nint(((isecdim-1)*dsecdim+osecdim)/dx)
            if (ixw-ihso >= 1 .and. ixw-ihso <= kxm%n .and. ixw+ihso >= 1 .and. ixw+ihso <= kxm%n) then
               image(ixw,isecdim)=image(ixw,isecdim)+conjg(ws(ixw-ihso))*wr(ixw+ihso)
            end if
         end do
      end do
   end if
end subroutine
end module
